function  [particelle1]=rilassa(celle,u,particelle,f,a,dt,epsi)
%
% Computes the relaxation step, i.e. re-distributes the microscopic velocities
%
n=length(celle);
fisico=1:n;
for j=fisico
   nj(j)=celle(j).number;
end
np=sum(nj);   % Total number of particles
rp=rand(np,1);
%
fu=feval(f,u(fisico)); 
ef(fisico)=0.5*(u+fu/a);
rel_time= exp(-dt/epsi); % relaxation time
collision = zeros(np,1);
% 1) Select the number of colliding particles in probability: 
% collision = (rp(:,1) > rel_time); % colliding particles
%
% 2) Or: compute the number of colliding particles as n_coll=nj(j)*(1-rel_time)
% and choose the first n_coll as colliding particles:
jj=0;
for j=fisico
  ncoll = fix((1-rel_time)*nj(j));
  collision(jj+1:jj+ncoll) = 1;
  collision(jj+ncoll+1:jj+nj(j)) = 0;
  jj=jj+nj(j); 
end
jj=0;
for j=fisico
  p1 = ef(j)/u(j);
  rp_cella=rp(jj+1:jj+nj(j),1);
  jj=jj+nj(j); 
  prova1=particelle(celle(j).i,2);
  particelle1(celle(j).i,2) = ( (2*a)*(rp_cella < p1*ones(nj(j),1)) -a) ...
                  .*collision(celle(j).i) + ...
                  particelle(celle(j).i,2).*(1-collision(celle(j).i));
  clear rp_cella
end
particelle1(:,1) = particelle(:,1);
